<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 管理下オブジェクト</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>管理下オブジェクト<br/>
<small>
[<a class="el" href="group__m17nCore.html">コア API</a>]</small>
</h1>
<p>参照回数で管理されるオブジェクト  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>データ構造</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structM17NObjectHead.html">M17NObjectHead</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">管理下オブジェクトの最初のメンバ.  <a href="structM17NObjectHead.html#_details">[詳細]</a><br/></td></tr>
<tr><td colspan="2"><h2>関数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nObject.html#ga90d6c570a21d615b60c2551b756e2de6">m17n_object</a> (int size, void(*freer)(void *))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">管理下オブジェクトを割り当てる.  <a href="#ga90d6c570a21d615b60c2551b756e2de6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nObject.html#ga690cd4bb0e346846bb82d8ab1d18fdee">m17n_object_ref</a> (void *object)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">管理下オブジェクトの参照数を 1 増やす.  <a href="#ga690cd4bb0e346846bb82d8ab1d18fdee"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b">m17n_object_unref</a> (void *object)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">管理下オブジェクトの参照数を 1 減らす.  <a href="#ga248ba287a615a2cf3cdb99c13275453b"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>参照回数で管理されるオブジェクト </p>
<p>管理下オブジェクトとは参照数によって管理されているオブジェクトである.</p>
<p>m17n オブジェクトのある型のものは、参照数によって管理されている。 それらのオブジェクトは <em>管理下オブジェクト</em> と呼ばれる。生成された時点での参照数は 1 に初期化されている。関数 <a class="el" href="group__m17nObject.html#ga690cd4bb0e346846bb82d8ab1d18fdee" title="管理下オブジェクトの参照数を 1 増やす.">m17n_object_ref()</a> は管理下オブジェクトの参照数を 1 増やし、関数m17n_object_unref() は 1 減らす。参照数が 0 になった管理下オブジェクトは自動的に解放される。</p>
<p>キーが管理キーであるプロパティは、値として管理下オブジェクトだけを取る。 関数 <a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="シンボルプロパティに値を設定する.">msymbol_put()</a> や <a class="el" href="group__m17nPlist.html#gafbfabe7a3e97e3dc6968263f61a3bee3" title="プロパティリスト中のプロパティの値を設定する.">mplist_put()</a> などはそれらのプロパティを特別扱いする。</p>
<p>定義済み管理下オブジェクトタイプの他に、ユーザは必要な管理下オブジェクトタイプを自分で定義することができる。詳細は <a class="el" href="group__m17nObject.html#ga90d6c570a21d615b60c2551b756e2de6" title="管理下オブジェクトを割り当てる.">m17n_object()</a> の説明を参照。 </p>
<hr/><h2>関数</h2>
<a class="anchor" id="ga90d6c570a21d615b60c2551b756e2de6"></a><!-- doxytag: member="m17n&#45;core.c::m17n_object" ref="ga90d6c570a21d615b60c2551b756e2de6" args="(int size, void(*freer)(void *))" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* m17n_object </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(void *)&nbsp;</td>
          <td class="paramname"> <em>freer</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>管理下オブジェクトを割り当てる. </p>
<p>関数 <a class="el" href="group__m17nObject.html#ga90d6c570a21d615b60c2551b756e2de6" title="管理下オブジェクトを割り当てる.">m17n_object()</a> は<b>size</b> バイトの新しい管理下オブジェクトを割り当て、その参照数を 1 とする。 <b>freer</b> は参照数が 0 になった際にそのオブジェクトを解放するために用いられる関数である。<b>freer</b> が NULLならば、オブジェクトは関数 free() によって解放される。</p>
<p>割り当てられたオブジェクト冒頭のバイトは、<a class="el" href="structM17NObjectHead.html" title="管理下オブジェクトの最初のメンバ.">M17NObjectHead</a> が占める。この領域は m17n ライブラリが使用するので、アプリケーションプログラムは触れてはならない。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>この関数は新しく割り当てられたオブジェクトを返す。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd>この関数は失敗しない。</dd></dl>
<dl class="user"><dt><b>例： </b></dt><dd><div class="fragment"><pre class="fragment"><span class="keyword">typedef</span> <span class="keyword">struct</span>
{
  <a class="code" href="structM17NObjectHead.html" title="管理下オブジェクトの最初のメンバ.">M17NObjectHead</a> head;
  <span class="keywordtype">int</span> mem1;
  <span class="keywordtype">char</span> *mem2;
} MYStruct;

<span class="keywordtype">void</span>
my_freer (<span class="keywordtype">void</span> *obj)
{
  free (((MYStruct *) obj)-&gt;mem2);
  free (obj);
}

<span class="keywordtype">void</span>
my_func (<a class="code" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec" title="MText の型宣言.">MText</a> *mt, <a class="code" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d" title="シンボルの型宣言.">MSymbol</a> key, <span class="keywordtype">int</span> num, <span class="keywordtype">char</span> *str)
{
  MYStruct *st = <a class="code" href="group__m17nObject.html#ga90d6c570a21d615b60c2551b756e2de6" title="管理下オブジェクトを割り当てる.">m17n_object</a> (<span class="keyword">sizeof</span> (MYStruct), my_freer);

  st-&gt;mem1 = num;
  st-&gt;mem2 = strdup (str);
  <span class="comment">/* KEY must be a managing key.   */</span>
  <a class="code" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="テキストプロパティを設定する.">mtext_put_prop</a> (mt, 0, <a class="code" href="group__m17nMtext.html#ga28ea3879a9dae45127bd62499645c7c3" title="M-text 中の文字の数.">mtext_len</a> (mt), key, st);
  <span class="comment">/* This sets the reference count of ST back to 1.  */</span>
  <a class="code" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b" title="管理下オブジェクトの参照数を 1 減らす.">m17n_object_unref</a> (st);
}
</pre></div> </dd></dl>

</div>
</div>
<a class="anchor" id="ga690cd4bb0e346846bb82d8ab1d18fdee"></a><!-- doxytag: member="m17n&#45;core.c::m17n_object_ref" ref="ga690cd4bb0e346846bb82d8ab1d18fdee" args="(void *object)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int m17n_object_ref </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>object</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>管理下オブジェクトの参照数を 1 増やす. </p>
<p>関数 <a class="el" href="group__m17nObject.html#ga690cd4bb0e346846bb82d8ab1d18fdee" title="管理下オブジェクトの参照数を 1 増やす.">m17n_object_ref()</a> は <b>object</b> で指される管理下オブジェクトの参照数を 1 増やす。</p>
<dl class="user"><dt><b>戻り値: </b></dt><dd>この関数は、増やした参照数が 16 ビットの符号無し整数値(すなわち 0x10000 未満)におさまれば、それを返す。そうでなければ -1 を返す。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd>この関数は失敗しない。 </dd></dl>

</div>
</div>
<a class="anchor" id="ga248ba287a615a2cf3cdb99c13275453b"></a><!-- doxytag: member="m17n&#45;core.c::m17n_object_unref" ref="ga248ba287a615a2cf3cdb99c13275453b" args="(void *object)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int m17n_object_unref </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>object</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>管理下オブジェクトの参照数を 1 減らす. </p>
<p>関数 <a class="el" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b" title="管理下オブジェクトの参照数を 1 減らす.">m17n_object_unref()</a> は <b>object</b> で指される管理下オブジェクトの参照数を 1 減らす。参照数が 0 になれば、オブジェクトは解放関数によって解放される。</p>
<dl class="user"><dt><b>戻り値: </b></dt><dd>この関数は、減らした参照数が 16 ビットの符号無し整数値(すなわち 0x10000 未満)におさまれば、それを返す。そうでなければ -1 を返す。つまり、0 が返って来た場合は<b>object</b> は解放されている。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd>この関数は失敗しない。 </dd></dl>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
